<template>
  <g>
    <!-- :key is used to force rerender of labels when they are selected and unselected -->
    <label-svg
      v-for="label in sortedLabels"
      :key="label.id + (label.id === selectedId ? '_' : '')"
      :label="label"
      :staves="staves"
      :pixel-unit="pixelUnit"
      :has-margin="hasMargin"
      :is-selected="label.id === selectedId"
      :is-focused="isFocused"
      :current-view-x="currentViewX"
      :pages="pages"
      :current-page="currentPage"
      :source-type="sourceType"
    />
    <!-- :test="console.log('test')" -->
  </g>
</template>
<script lang="ts">
import {
  Component, Prop, Vue,
} from 'vue-property-decorator';
import type {
  Label, LabelId, Staff, Unit, Pixel,
} from '@/data';

import type { Image3DPageData, SourceType } from '@/data/Source';
import LabelSvg from './LabelSvg.vue';

/**
 * A wrapper for the labels, to make sure they don't rerender for nothing
 *
 * To test performance, add a console log on property resolution
 */
@Component({ components: { LabelSvg } })
export default class LabelGroupSvg extends Vue {
  // get console() { return console; }

  @Prop()
  pages!: Array<Image3DPageData>;

  @Prop({ required: true })
  hasMargin!: boolean;

  @Prop({ required: true })
  sortedLabels!: Label[];

  @Prop({ required: true })
  pixelUnit!: Unit<Pixel>;

  @Prop({ required: true })
  staves!: Staff[];

  @Prop({ default: null })
  selectedId!: LabelId | null;

  @Prop({ required: true })
  isFocused!: boolean;

  @Prop({
    default: 0,
    type: Number,
  })
  currentViewX!: Pixel;

  @Prop()
  currentPage!: number;

  @Prop()
  sourceType!: SourceType;
}
</script>
